package com.aliyun.iot.ilop.page.deviceadd.product;

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.aliyun.iot.ilop.component.deviceadd.module.Product;
import com.aliyun.iot.ilop.page.device.add.R;
import com.aliyun.iot.ilop.page.deviceadd.product.viewholder.HeaderViewHolder;
import com.aliyun.iot.ilop.page.deviceadd.product.viewholder.ProductViewHolder;

import java.util.LinkedList;
import java.util.List;

/**
 * @author guikong on 18/4/10.
 */

public class ProductListAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private final static int VIEW_TYPE_HEAD = 0;
    private final static int VIEW_TYPE_PRODUCT = 1;

    private List<Product> data;

    ProductListAdapter() {
        data = new LinkedList<>();
    }

    void addCategory(List<Product> products) {
        int index = getItemCount();
        data.addAll(products);
        notifyItemInserted(index);
    }

    @Override
    public int getItemViewType(int position) {
        if (position == 0) {
            return VIEW_TYPE_HEAD;
        }

        return VIEW_TYPE_PRODUCT;
    }

    @Override
    public int getItemCount() {
        return data.size() + 1;
    }

    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        if (null == parent) {
            return null;
        }

        Context context = parent.getContext();

        if (VIEW_TYPE_HEAD == viewType) {
            LayoutInflater inflater = LayoutInflater.from(context);
            View view = inflater.inflate(R.layout.deviceadd_product_list_header_recycle_item, parent, false);
            return new HeaderViewHolder(view);
        }

        LayoutInflater inflater = LayoutInflater.from(context);
        View view = inflater.inflate(R.layout.deviceadd_product_list_product_recycle_item, parent, false);
        return new ProductViewHolder(view);
    }

    @Override
    public void onBindViewHolder(RecyclerView.ViewHolder holder, int position) {
        if (VIEW_TYPE_HEAD == getItemViewType(position)) {
            return;
        }

        Product product = data.get(position - 1);
        int count = getItemCount();
        if (holder instanceof ProductViewHolder) {
            ((ProductViewHolder) holder).setProduct(product, position, count);
        }
    }
}
