package com.aliyun.iot.ilop.page.mine.smallcomponents.activity;

import android.os.Bundle;
import android.support.v7.widget.GridLayoutManager;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.helper.ItemTouchHelper;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.aliyun.iot.ilop.page.mine.R;
import com.aliyun.iot.ilop.page.mine.base.MineBaseActivity;
import com.aliyun.iot.ilop.page.mine.smallcomponents.adapter.SmallComponentAddSceneAdapter;
import com.aliyun.iot.ilop.page.mine.smallcomponents.adapter.SmallComponentNotSceneAdapter;
import com.aliyun.iot.ilop.page.mine.smallcomponents.bean.SmallComponentSceneBean;

import java.util.ArrayList;
import java.util.Collections;

public class SmallComponentSceneActivity extends MineBaseActivity implements View.OnClickListener {

    private TextView tv_save_scene;
    private ImageView iv_add_scene_back;
    private TextView tv_scene_num;
    private RecyclerView lv_scene_view;
    private LinearLayout ll_no_scene;
    private ArrayList scene_list_added = new ArrayList();
    private ArrayList scene_list_not_added = new ArrayList();
    private SmallComponentNotSceneAdapter smallComponentSceneAdapter;
    private RecyclerView recy_add_scene;
    private SmallComponentAddSceneAdapter smallComponentAddSceneAdapter;
    private int current_drag_position = 0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ilop_mine_small_component_scene_activity);
    }

    @Override
    protected void initView() {
        tv_save_scene = findViewById(R.id.tv_save_scene);
        iv_add_scene_back = findViewById(R.id.iv_add_scene_back);
        tv_scene_num = findViewById(R.id.tv_scene_num);
        lv_scene_view = findViewById(R.id.lv_scene_view);
        ll_no_scene = findViewById(R.id.ll_no_scene);
        recy_add_scene = findViewById(R.id.recy_add_scene);
    }

    @Override
    protected void initData() {
        scene_list_not_added.add(new SmallComponentSceneBean("", "场景1", false));
        scene_list_not_added.add(new SmallComponentSceneBean("", "场景2", false));
        scene_list_not_added.add(new SmallComponentSceneBean("", "场景3", false));
        scene_list_not_added.add(new SmallComponentSceneBean("", "场景4", false));
        scene_list_added.add(new SmallComponentSceneBean("", "场景5", true));
        scene_list_added.add(new SmallComponentSceneBean("", "场景6", true));
        scene_list_added.add(new SmallComponentSceneBean("", "场景7", true));
        scene_list_added.add(new SmallComponentSceneBean("", "场景8", true));
        scene_list_added.add(new SmallComponentSceneBean("", "场景9", true));
        //记录已添加场景个数
        recordSceneNum();
        smallComponentSceneAdapter = new SmallComponentNotSceneAdapter(scene_list_not_added, this);
        lv_scene_view.setLayoutManager(new LinearLayoutManager(this));
        lv_scene_view.setAdapter(smallComponentSceneAdapter);

        recy_add_scene.setLayoutManager(new GridLayoutManager(this, 4));
        smallComponentAddSceneAdapter = new SmallComponentAddSceneAdapter(scene_list_added, this);
        recy_add_scene.setAdapter(smallComponentAddSceneAdapter);

       /*
        DefaultItemAnimator defaultItemAnimator = new DefaultItemAnimator();
        defaultItemAnimator.setAddDuration(100);
        defaultItemAnimator.setRemoveDuration(100);
        recy_add_scene.setItemAnimator(defaultItemAnimator);
        lv_scene_view.setItemAnimator(defaultItemAnimator);*/
    }

    /**
     * 记录添加场景个数
     */
    private void recordSceneNum() {
        tv_scene_num.setText(scene_list_added.size() + "");
        if (scene_list_not_added.size() > 0) {
            ll_no_scene.setVisibility(View.GONE);
            lv_scene_view.setVisibility(View.VISIBLE);
        } else {
            ll_no_scene.setVisibility(View.VISIBLE);
            lv_scene_view.setVisibility(View.GONE);
        }
    }

    //itemHelper的回调
    ItemTouchHelper.Callback callback = new ItemTouchHelper.Callback() {
        /**
         *官方文档的说明如下：
         *
         o control
         which actions
         user can
         take on
         each view, you
         should override

         getMovementFlags(RecyclerView, View
         Holder)
         *and return
         appropriate set
         of direction flags.(LEFT,RIGHT,START,END,UP,DOWN).
         *返回我们要监控的方向，上下左右，我们做的是上下拖动，要返回都是UP和DOWN
         *关键坑爹的是下面方法返回值只有1个，也就是说只能监控一个方向。
         *不过点入到源码里面有惊喜。源码标记方向如下：
         *
         public static final int UP = 1     0001
         *
         public static final int DOWN = 1 << 1; （位运算：值其实就是2）0010
         *
         public static final int LEFT = 1 << 2
         左 值是3
         *
         public static final int RIGHT = 1 << 3
         右 值是8
         */

        @Override
        public int getMovementFlags(RecyclerView recyclerView, RecyclerView.ViewHolder viewHolder) {
            //也就是说返回值是组合式的
            // makeMovementFlags (int dragFlags, int swipeFlags)，看下面的解释说明
            // int swipFlag=ItemTouchHelper.LEFT|ItemTouchHelper.RIGHT;
            //如果也监控左右方向的话，swipFlag=ItemTouchHelper.LEFT|ItemTouchHelper.RIGHT;
            //int dragflag = ItemTouchHelper.UP | ItemTouchHelper.DOWN;
            int dragflag = ItemTouchHelper.UP | ItemTouchHelper.DOWN |
                    ItemTouchHelper.LEFT | ItemTouchHelper.RIGHT;
            int swipFlag = 0;
            //等价于：0001&0010;多点触控标记触屏手指的顺序和个数也是这样标记哦
            current_drag_position = viewHolder.getAdapterPosition();
            return makeMovementFlags(dragflag, swipFlag); /**
             *备注：由getMovementFlags可以联想到setMovementFlags，不过文档么有这个方法，但是：
             *有 makeMovementFlags ( int dragFlags, int swipeFlags)
             *Convenience method to create movement flags.便捷方法创建moveMentFlag
             * For instance,if you want to let your items be drag &dropped vertically
             and swiped
             left to be dismissed,
             *you can call this method with:makeMovementFlags(UP | DOWN, LEFT);
             *这个recyclerview的文档写的简直完美，示例代码都弄好了！！！
             *如果你想让item上下拖动和左边滑动删除，应该这样用：makeMovementFlags(UP | DOWN, LEFT)
             */
            //拓展一下：如果只想上下的话：makeMovementFlags（UP | DOWN, 0）,标记方向的最小值1
        }

        /**
         *官方文档的说明如下
         * If user drags an item, ItemTouchHelper will call
         onMove(recyclerView, dragged, target).Upon receiving this callback,
         *you should move the item from the old position(dragged.getAdapterPosition()) to
         new position(target.getAdapterPosition())
         * in your adapter and also call notifyItemMoved ( int,int).
         *拖动某个item的回调，在return前要更新item位置，调用notifyItemMoved（draggedPosition，targetPosition）
         *viewHolde:
         正在拖动item
         * target：要拖到的目标
         * @return true 表示消费事件
         */
        @Override
        public boolean onMove(RecyclerView recyclerView, RecyclerView.ViewHolder viewHolder, RecyclerView.ViewHolder target) {

            if (target.getAdapterPosition() < scene_list_added.size()) {
                //直接按照文档来操作啊，这文档写得太给力了,简直完美！
                smallComponentAddSceneAdapter.notifyItemMoved(viewHolder.getAdapterPosition(), target.getAdapterPosition());
                //注意这里有个坑的，itemView 都移动了，对应的数据也要移动
                Collections.swap(scene_list_added, viewHolder.getAdapterPosition(), target.getAdapterPosition());
            }
            return true;
        }

        /**
         *谷歌官方文档说明如下：
         *这个看了一下主要是做左右拖动的回调
         * When a View is swiped, ItemTouchHelper animates it until it goes out
         of bounds, then calls onSwiped (ViewHolder,int).
         *At this point, you should update your adapter (e.g.remove the item)and call
         related Adapter#notify event.
         *@param viewHolder
         * @param direction
         */
        @Override
        public void onSwiped(RecyclerView.ViewHolder viewHolder,
                             int direction) {
            //暂不处理
        }

        /**
         *官方文档如下：返回true 当前tiem可以被拖动到目标位置后，直接”落“在target上，其他的上面的tiem跟着“落”，
         *所以要重写这个方法，不然只是拖动的tiem在动，target tiem不动，静止的
         * Return true if the current ViewHolder can be dropped over the the target
         ViewHolder.
         * @param recyclerView
         * @param current
         * @param target
         * @return
         */
        @Override
        public boolean canDropOver(RecyclerView recyclerView, RecyclerView.ViewHolder
                current, RecyclerView.ViewHolder target) {
            return true;
        }

        /**
         * 官方文档说明如下：
         * Returns whether ItemTouchHelper should start a drag and drop operation if an item is long pressed.
         * 是否开启长按 拖动
         * @return
         */
        @Override
        public boolean isLongPressDragEnabled() {
            //return true后，可以实现长按拖动排序和拖动动画了
            if (current_drag_position >= scene_list_added.size()) {
                return false;
            }
            return true;
        }
    };


    @Override
    protected void initEvent() {
        tv_save_scene.setOnClickListener(this);
        iv_add_scene_back.setOnClickListener(this);
        //1.创建item helper
        ItemTouchHelper itemTouchHelper = new ItemTouchHelper(callback);
        // 2.绑定到recyclerview上面去
        itemTouchHelper.attachToRecyclerView(recy_add_scene);
        // 3.在ItemHelper的接口回调中过滤开启长按拖动，拓展其他操作
        //添加场景
        smallComponentSceneAdapter.setOnAddSceneListener(new SmallComponentNotSceneAdapter.onAddSceneListener() {
            @Override
            public void addScene(int position) {
                //判断是否满足8个
                //以满足提示
                //为满足直接添加
                if (scene_list_added.size() == 8) {
                    Toast toast = new Toast(SmallComponentSceneActivity.this);
                    View view = LayoutInflater.from(SmallComponentSceneActivity.this).inflate(R.layout.ilop_mine_small_component_toast, null);
                    toast.setView(view);
                    toast.setGravity(Gravity.CENTER, 0, 0);
                    toast.show();
                } else {
                    SmallComponentSceneBean smallComponentSceneBean = (SmallComponentSceneBean) scene_list_not_added.get(position);

                    scene_list_added.add(smallComponentSceneBean);
                    scene_list_not_added.remove(position);
                    smallComponentAddSceneAdapter.notifyDataSetChanged();
                    smallComponentSceneAdapter.notifyDataSetChanged();
                    recordSceneNum();
                }

            }
        });
        //删除场景
        smallComponentAddSceneAdapter.setOnDeteleSceneListener(new SmallComponentAddSceneAdapter.OnDeteleSceneListener() {
            @Override
            public void onDeleteScene(int position) {
                SmallComponentSceneBean smallComponentSceneBean = (SmallComponentSceneBean) scene_list_added.get(position);
                scene_list_added.remove(position);
                scene_list_not_added.add(smallComponentSceneBean);
                smallComponentAddSceneAdapter.notifyDataSetChanged();
                smallComponentSceneAdapter.notifyDataSetChanged();
                recordSceneNum();
            }
        });
    }

    @Override
    protected void initHandler() {

    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.iv_add_scene_back) {
            this.finish();
        } else if (v.getId() == R.id.tv_save_scene) {

        }
    }

}
