package com.aliyun.iot.homelink.demo.page.scene;

import java.io.IOException;
import java.io.InputStream;

import okio.BufferedSource;
import okio.Okio;

/**
 * @author sinyuk
 * @date 2018/6/14
 */
public class AssetsUtils {
    private static class SingletonHolder {
        private static final AssetsUtils INSTANCE = new AssetsUtils();
    }

    private AssetsUtils() {
    }

    public static AssetsUtils getInstance() {
        return AssetsUtils.SingletonHolder.INSTANCE;
    }

    public String mockResponse(String fileName) throws IOException {
        InputStream inputStream =
                getClass().getResourceAsStream("/assets/api-response/" + fileName);
        BufferedSource source = Okio.buffer(Okio.source(inputStream));
        return source.readByteString().utf8();
    }
}
