package com.aliyun.iot.homelink.demo.page.scene.details;

import com.alibaba.fastjson.JSON;
import com.aliyun.iot.homelink.demo.page.scene.AssetsUtils;
import com.aliyun.iot.homelink.demo.page.scene.api.DetailsResponse;

import java.io.IOException;

/**
 * @author sinyuk
 * @date 2018/6/19
 */
class MockDetailListPresenter implements DetailListContract.Presenter {
    private final DetailListContract.View detailListView;

    MockDetailListPresenter(DetailListContract.View detailListView) {
        this.detailListView = detailListView;
        this.detailListView.setPresenter(this);
    }

    @Override
    public void loadDetails(int pageNo) {
        if (pageNo == 1) {
            detailListView.showRefresh();
        }

        try {
            final DetailsResponse data = JSON.parseObject(
                    AssetsUtils.getInstance().mockResponse("failed_log_get.json"),
                    DetailsResponse.class);
            if (1 == pageNo) {
                detailListView.initDetails(data);
                detailListView.hideRefresh();
            } else {
                detailListView.loadMoreDetails(data);
            }
        } catch (IOException e) {
            String error = e.getMessage();
            if (1 == pageNo) {
                detailListView.refreshFailed(error);
            } else {
                detailListView.loadMoreFailed(error);
            }
        }
    }

    @Override
    public String logId() {
        return null;
    }

    @Override
    public String sceneId() {
        return null;
    }

    @Override
    public long time() {
        return 0;
    }

    @Override
    public void start() {
        loadDetails(1);
    }
}
