package com.aliyun.iot.homelink.demo.page.scene.details;

import com.aliyun.iot.homelink.demo.page.scene.BasePresenter;
import com.aliyun.iot.homelink.demo.page.scene.BaseView;
import com.aliyun.iot.homelink.demo.page.scene.api.DetailsResponse;

/**
 * The interface Details contract.
 *
 * @author sinyuk
 * @date 2018 /6/19
 */
public interface DetailListContract {
    /**
     * The interface View.
     */
    interface View extends BaseView<Presenter> {
        /**
         * Init logs.
         *
         * @param data the data
         */
        void initDetails(DetailsResponse data);


        /**
         * Load more logs.
         *
         * @param data the data
         */
        void loadMoreDetails(DetailsResponse data);


        /**
         * Hide load more.
         *
         * @param message the message
         */
        void loadMoreFailed(String message);

        /**
         * Refresh failed.
         *
         * @param message the message
         */
        void refreshFailed(String message);

        /**
         * Hide refresh.
         */
        void hideRefresh();

        /**
         * Show refresh.
         */
        void showRefresh();
    }

    /**
     * The interface Presenter.
     */
    interface Presenter extends BasePresenter {
        /**
         * Load logs.
         *
         * @param pageNo the page no
         */
        void loadDetails(int pageNo);


        /**
         * Log id string.
         *
         * @return the string
         */
        String logId();

        /**
         * Scene id string.
         *
         * @return the string
         */
        String sceneId();

        /**
         * Time long.
         *
         * @return the long
         */
        long time();
    }
}
