package com.aliyun.iot.homelink.demo.page.scene.details;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v7.app.AppCompatActivity;

import com.aliyun.iot.homelink.demo.page.scene.R;
import com.aliyun.iot.homelink.demo.page.scene.data.SceneRepository;

/**
 * @author sinyuk
 * @date 2018/6/19
 */
public class DetailsActivity extends AppCompatActivity {
    /**
     * @param context context
     * @param logId   待查询的日志id
     * @param sceneId 场景id
     * @param time    logs.time/单位:毫秒
     */
    public static void start(Context context, String groupId, String logId, String sceneId, long time) {
        Intent starter = new Intent(context, DetailsActivity.class);
        starter.putExtra("groupId", groupId);
        starter.putExtra("logId", logId);
        starter.putExtra("sceneId", sceneId);
        starter.putExtra("time", time);
        starter.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_SINGLE_TOP);
        context.startActivity(starter);
    }

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.details_activity);

        DetailListFragment fragment = new DetailListFragment();
        new DetailListPresenter(
                getIntent().getStringExtra("groupId"),
                getIntent().getStringExtra("logId"),
                getIntent().getStringExtra("sceneId"),
                getIntent().getLongExtra("time", 0L),
                SceneRepository.getInstance(),
                fragment);
        if (savedInstanceState == null) {
            getSupportFragmentManager().beginTransaction()
                    .add(R.id.fragment_container, fragment, DetailListFragment.class.getSimpleName())
                    .disallowAddToBackStack()
                    .commit();
        }
    }
}
