package com.aliyun.iot.homelink.demo.page.scene.list;

import android.content.Context;
import android.graphics.Rect;
import android.support.v7.widget.RecyclerView;
import android.view.View;

/**
 * The margin decoration of scene list item.
 *
 * @author sinyuk
 * @date 2018 /6/15
 */
class MarginDecoration extends RecyclerView.ItemDecoration {
    private int margin;

    MarginDecoration(int resId, Context context) {
        margin = context.getResources().getDimensionPixelOffset(resId);
    }

    @Override
    public void getItemOffsets(Rect outRect, View view, RecyclerView parent, RecyclerView.State state) {
        int position = parent.getChildAdapterPosition(view);
        // top edge
        if (position == 0) {
            outRect.top = margin;
        }
        outRect.bottom = margin;
    }
}
