package com.aliyun.iot.homelink.demo.page.scene.log;

import android.graphics.drawable.Drawable;
import android.support.v4.content.ContextCompat;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import com.aliyun.iot.homelink.demo.page.scene.R;
import com.aliyun.iot.homelink.demo.page.scene.entities.Log;
import com.aliyun.iot.homelink.demo.page.scene.widgets.Divided;
import com.bumptech.glide.Glide;
import com.bumptech.glide.RequestBuilder;
import com.bumptech.glide.request.RequestOptions;
import com.chad.library.adapter.base.BaseViewHolder;

import java.sql.Timestamp;
import java.util.Date;


/**
 * @author sinyuk
 * @date 2018/6/15
 */
class LogItemViewHolder extends BaseViewHolder implements Divided {
    private final int textError;
    private final int textSecondary;


    private final TextView result;
    private final TextView time;
    private final Drawable entryDrawable;
    private final ImageView icon;
    private final RequestBuilder<Drawable> builder;

    LogItemViewHolder(View view) {
        super(view);
        textError = ContextCompat.getColor(view.getContext(), R.color.themeRed);
        textSecondary = ContextCompat.getColor(view.getContext(), R.color.textColorSecondary);
        builder = Glide.with(view).asDrawable().apply(new RequestOptions().circleCrop());
        result = view.findViewById(R.id.result);
        time = view.findViewById(R.id.time);
        entryDrawable = ContextCompat.getDrawable(view.getContext(), R.drawable.ic_next);
        icon = view.findViewById(R.id.icon);
    }

    void bind(Log log) {
        if (log.result == 0) {
            result.setText(R.string.log_result_failed);
            result.setTextColor(textError);
            time.setCompoundDrawablesWithIntrinsicBounds(null, null, entryDrawable, null);
        } else {
            result.setText(R.string.log_result_succeed);
            result.setTextColor(textSecondary);
            time.setCompoundDrawablesWithIntrinsicBounds(null, null, null, null);
        }
        time.setText(log.getTime());
        setText(R.id.sceneName, log.sceneName);
        builder.load(log.icon).into(icon);
    }

}
