package com.aliyun.iot.homelink.demo.page.scene.log;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v7.app.AppCompatActivity;

import com.aliyun.iot.homelink.demo.page.scene.BuildConfig;
import com.aliyun.iot.homelink.demo.page.scene.R;
import com.aliyun.iot.homelink.demo.page.scene.Utils;
import com.aliyun.iot.homelink.demo.page.scene.data.SceneRepository;

import static com.aliyun.iot.homelink.demo.page.scene.Utils.checkNotNull;

/**
 * @author sinyuk
 * @date 2018/6/14
 */
public class LogListActivity extends AppCompatActivity {
    /**
     * @param context context
     * @param groupId current house id
     */
    public static void start(Context context, String groupId) {
        Intent starter = new Intent(context, LogListActivity.class);
        starter.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_SINGLE_TOP);
        starter.putExtra("groupId", groupId);
        context.startActivity(starter);
    }

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.log_list_activity);
        String groupId = null;
        if (getIntent() != null) {
            groupId = getIntent().getStringExtra("groupId");
        }
        if (savedInstanceState == null) {
            LogListFragment fragment = new LogListFragment();
            checkNotNull(groupId);
            new LogListPresenter(
                    SceneRepository.getInstance(),
                    fragment,
                    groupId,
                    System.currentTimeMillis());
            getSupportFragmentManager().beginTransaction()
                    .add(R.id.fragment_container, fragment, LogListFragment.class.getSimpleName())
                    .disallowAddToBackStack()
                    .commit();
        }
    }


}
