package com.aliyun.iot.homelink.demo.page.scene.log;

import com.aliyun.iot.homelink.demo.page.scene.BasePresenter;
import com.aliyun.iot.homelink.demo.page.scene.BaseView;
import com.aliyun.iot.homelink.demo.page.scene.api.LogsResponse;
import com.aliyun.iot.homelink.demo.page.scene.api.ScenesResponse;

/**
 * The interface Log contract.
 *
 * @author sinyuk
 * @date 2018 /6/14
 */
public interface LogListContract {
    /**
     * The interface View.
     */
    interface View extends BaseView<Presenter> {
        /**
         * Init logs.
         *
         * @param data the data
         */
        void initLogs(LogsResponse data);


        /**
         * Load more logs.
         *
         * @param data the data
         */
        void loadMoreLogs(LogsResponse data);


        /**
         * Hide load more.
         *
         * @param message the message
         */
        void loadMoreFailed(String message);

        /**
         * Refresh failed.
         *
         * @param message the message
         */
        void refreshFailed(String message);

        /**
         * Hide refresh.
         */
        void hideRefresh();

        /**
         * Show refresh.
         */
        void showRefresh();
    }

    /**
     * The interface Presenter.
     */
    interface Presenter extends BasePresenter {
        /**
         * Load logs.
         *
         * @param pageNo the page no
         */
        void loadLogs(int pageNo);

        /**
         * Update timestamp.
         *
         * @param time the time
         */
        void updateTimestamp(long time);

        /**
         * Group id string.
         *
         * @return the string
         */
        String groupId();
    }
}
