package com.aliyun.iot.homelink.demo.page.share.data;

import android.support.annotation.VisibleForTesting;

import com.google.gson.annotations.SerializedName;

import java.util.ArrayList;
import java.util.List;

/**
 * @author sinyuk
 * @date 2018/6/27
 */
public class DeviceResponse {
    public int total;
    public List<Device> data;

    public static class Device {
        public String productName;
        public String categoryImage;
        @SerializedName("nickName")
        public String nickName;
    }

    public static final int MAX_VISIBLE_COUNT = 10;

    @SuppressWarnings("unused")
    @VisibleForTesting
    public static DeviceResponse mock(int count) {
        DeviceResponse response = new DeviceResponse();
        response.total = count;
        List<Device> devices = new ArrayList<>();
        for (int i = 1; i <= count; i++) {
            Device item = new Device();
            item.productName = "设备" + i;
            item.categoryImage = "";
            devices.add(item);
        }
        response.data = devices;
        return response;
    }

}
