package com.aliyun.iot.homelink.demo.page.share.ui;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.support.annotation.Nullable;
import android.widget.ImageView;

import com.aliyun.iot.homelink.demo.page.R;
import com.aliyun.iot.homelink.demo.page.share.data.DeviceResponse;
import com.bumptech.glide.Glide;
import com.bumptech.glide.RequestBuilder;
import com.bumptech.glide.request.RequestOptions;
import com.chad.library.adapter.base.BaseQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;

import java.util.List;

/**
 * @author sinyuk
 * @date 2018/6/27
 */
public class DeviceShareAdapter extends BaseQuickAdapter<DeviceResponse.Device, BaseViewHolder> {

    private final RequestBuilder<Drawable> builder;

    DeviceShareAdapter(@Nullable List<DeviceResponse.Device> data, Context context) {
        super(R.layout.list_item_device, data);
        builder = Glide.with(context).asDrawable()
                .apply(new RequestOptions()
                        .error(R.drawable.device_placeholder)
                        .fallback(R.drawable.device_placeholder)
                        .centerInside());
    }

    @Override
    protected void convert(BaseViewHolder helper, DeviceResponse.Device item) {
        if (item.nickName != null) {
            helper.setText(R.id.name, item.nickName);
        } else {
            helper.setText(R.id.name, item.productName);
        }
        builder.load(item.categoryImage).into((ImageView) helper.getView(R.id.icon));
    }
}
