package com.aliyun.iot.homelink.demo.page.share.ui;

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v7.app.AppCompatActivity;

import com.aliyun.iot.homelink.demo.page.R;

/**
 * @author sinyuk
 * @date 2018/6/26
 */
public class ShareActivity extends AppCompatActivity {
    public static final String KEY_ROOM_ID = "roomId";
    public static final String KEY_GROUP_ID = "groupId";
    public static final String KEY_HOUSE_NAME = "houseName";
    public static final String KEY_ROOM_NAME = "roomName";
    private ShareFragment fragment;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.share_activity);
        assert null != getIntent();
        String groupId = getIntent().getStringExtra(KEY_GROUP_ID);
        String roomId = getIntent().getStringExtra(KEY_ROOM_ID);
        String houseName = getIntent().getStringExtra(KEY_HOUSE_NAME);
        String roomName = getIntent().getStringExtra(KEY_ROOM_NAME);
        String bizType;
        if (roomId == null) {
            bizType = ShareViewPresenter.ACTION_HOUSE_SHARE;
        } else {
            bizType = ShareViewPresenter.ACTION_ROOM_SHARE;
            if (null == roomName) {
                roomName = "房间内";
            }
        }
        if (getSupportFragmentManager()
                .findFragmentByTag(ShareFragment.class.getSimpleName()) == null) {
            fragment = new ShareFragment();
            getSupportFragmentManager().beginTransaction()
                    .add(R.id.fragment_container, fragment, ShareFragment.class.getSimpleName())
                    .disallowAddToBackStack()
                    .commit();
        }
        new ShareViewPresenter(bizType, groupId, roomId, houseName, roomName, fragment);
    }

}
